package cz.upol.jj1.lecture12;


import org.junit.jupiter.api.*;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.ValueSource;
import static org.junit.jupiter.api.Assertions.*;
import static org.junit.jupiter.api.Assumptions.assumeTrue;


public class TestMatrixGenerator {

    Matrix const1;
    Matrix const2;
    Matrix result;
    Matrix random3x2;
    Matrix random2x3;

    @BeforeAll
    static void initAll() {
    System.out.println("Vykonam se pri inicializaci cele tridy...");
    }

    @BeforeEach
    void init() {
        const1 = new Matrix(1,1,1);
        const2 = new Matrix(1,1,2);
        result = null;
        random2x3 = new Matrix(2,3);
        random3x2 = new Matrix(3,2);
        System.out.println("Vykonavam se pred kazdym testem...");
    }

    @Test
    void multiplicationTest() {
        System.out.println("test");
        assertEquals(Matrix.multiply(const1, const2), const2);
    }

    @Test
    void additionTest() {
        System.out.println("test");
        assertEquals(Matrix.add(const1, const1), const2);
    }

    @Test
    @DisplayName("Kontrola, jestli nasobeni vyvola vyjimku, kdyz nesedi dimenze")
    void exceptionMultiplicationTest() {
        System.out.println("test");
        assertThrows(IllegalArgumentException.class, () -> Matrix.multiply(const1, random3x2));
    }

    @Test
    @Disabled("VYPNUTO: Tento test zapneme, az doladime odcitani matic.")
    void subtractionTest() {
        System.out.println("test");
        assertEquals(const1, Matrix.subtract(const2, const1));
    }



    @ParameterizedTest
    @ValueSource(ints = { 1, 2, 3})
    @DisplayName("Je (1) jednotka pro matice 1x1?")
    void const1IsUnit(int candidate) {
        System.out.println("test");
        Matrix constCandidate = new Matrix(1,1,candidate);
        assertEquals(constCandidate, Matrix.multiply(constCandidate, const1));
    }



    @Test
    void wrongAssumptionTest() {
        System.out.println("test");
        assumeTrue(const1.equals(const2));
        fail("1 = 2? Opravdu??");
    }

    @AfterEach
    void tearDown() {
        System.out.println("Ja bych po kazdem testu uklizel...");
    }

    @AfterAll
    static void tearDownAll() {
        System.out.println("Posledni zhasina!");
    }

}

